Attribute VB_Name = "Sample"
'====================================================================
' pas2000s.bas
'--------------------------------------------------------------------
'
' PA-S2000 Sample
'
'--------------------------------------------------------------------
' CH1CALM͂AgKʒȗÕf[^\܂B
'====================================================================
Option Explicit

Private Const WM_CLOSE = &H10
Private Const WM_USER = &H400
Private Const GWL_WNDPROC = -4

Private Const WM_PAS2000_BASE = WM_USER + 100
Private Const WM_PAS2000_DATA_READY = WM_PAS2000_BASE + WM_DATA_READY
Private Const WM_PAS2000_ERROR = WM_PAS2000_BASE + WM_DATA_THREAD_ERROR
Private Const szTitle = "Sample"

Private Declare Function CallWindowProc Lib "user32" Alias "CallWindowProcA" (ByVal lpPrevWndFunc As Long, ByVal hWnd As Long, ByVal MSG As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
Private Declare Function SetWindowLong Lib "user32" Alias "SetWindowLongA" (ByVal hWnd As Long, ByVal nIndex As Long, ByVal dwNewLong As Long) As Long
Private Declare Function SendMessage Lib "user32" Alias "SendMessageA" (ByVal hWnd As Long, ByVal MSG As Long, ByVal wParam As Long, ByVal lParam As Long) As Long

Global lpPrevWndProc As Long
Global ghWnd As Long
Global mwDeviceNo As Integer
Global mpdwADData() As Long
Global mSetMode As TSETMODE

'--------------------------------------------------------------------
' 
'--------------------------------------------------------------------
Public Sub OnLoad()
    Dim szbuf As String
    Dim dwDrvVer As Long
    Dim dwDllVer As Long
    Dim dwMemSize As Long
    Dim DevInfo As TDEVINFO

    '-----------------------------------------------------------
    ' DLL̎gp錾
    '-----------------------------------------------------------
    If Pas2000wDllOpen() = False Then
        ErrorMessage (PAS2000_DEVICE_AUTO)
    End If
    '-----------------------------------------------------------
    ' foCX̎gp錾
    '-----------------------------------------------------------
    mwDeviceNo = PAS2000_DEVICE_AUTO
    If Pas2000wCreate(mwDeviceNo, ghWnd, WM_PAS2000_BASE) = False Then
        ErrorMessage (PAS2000_DEVICE_AUTO)
    End If
    szbuf = "foCX " + Format(mwDeviceNo) + " ̎gp錾܂B"
    ResultMessage (szbuf)
    '-----------------------------------------------------------
    ' o[W擾
    '-----------------------------------------------------------
    If Pas2000wGetVersion(dwDrvVer, dwDllVer) = False Then
        ErrorMessage (PAS2000_DEVICE_AUTO)
    End If
    szbuf = "o[W" + Chr(10) + _
            "   Driver Version : &H" + Hex(dwDrvVer) + Chr(10) + _
            "   DLL Version : &H" + Hex(dwDllVer)
    ResultMessage (szbuf)
    '-----------------------------------------------------------
    ' foCX擾
    '-----------------------------------------------------------
    If Pas2000wGetDevInfo(mwDeviceNo, DevInfo) = False Then
        ErrorMessage (mwDeviceNo)
    End If
    szbuf = "foCX" + Chr(10) + _
            "   Firm Version : " + FormatNumber((DevInfo.FirmVer \ 100) + (DevInfo.FirmVer Mod 100) * 0.01, 2, vbTrue) + Chr(10) + _
            "   FPGA Version : " + FormatNumber((DevInfo.FpgaVer \ 100) + (DevInfo.FpgaVer Mod 100) * 0.01, 2, vbTrue)
    ResultMessage (szbuf)
    '-----------------------------------------------------------
    ' TCY擾
    '-----------------------------------------------------------
    If Pas2000wGetMemSize(mwDeviceNo, dwMemSize) = False Then
        ErrorMessage (mwDeviceNo)
    End If
    szbuf = "TCY" + Chr(10)
    If dwMemSize = 0 Then
        szbuf = szbuf + "   128K|Cg"
    Else
        szbuf = szbuf + "   1M|Cg"
    End If
    ResultMessage (szbuf)
    '-----------------------------------------------------------
    ' TvO샂[hݒ
    '-----------------------------------------------------------
    'ݒ
    mSetMode.dwVoltDiv(PAS2000_CH1) = PAS2000_VOLTDIV_1     ' XP[
    mSetMode.dwVoltDiv(PAS2000_CH2) = PAS2000_VOLTDIV_1
    mSetMode.dwVoltPos(PAS2000_CH1) = 100                   ' |WV
    mSetMode.dwVoltPos(PAS2000_CH2) = 100
    mSetMode.dwVertCoupling(PAS2000_CH1) = PAS2000_CUP_DC   ' ͌
    mSetMode.dwVertCoupling(PAS2000_CH2) = PAS2000_CUP_DC
    ' ݒ
    mSetMode.dwMemSize = PAS2000_MEMSIZE_10K                ' TCY
    mSetMode.dwSamplingTime = PAS2000_TIMEDIV_200NS         ' XP[
    mSetMode.dwBandWidth(PAS2000_CH1) = PAS2000_BW_FULL     ' gш
    mSetMode.dwBandWidth(PAS2000_CH2) = PAS2000_BW_FULL
    mSetMode.dwSamplingMode = PAS2000_SMP_REAL              ' TvO[h
    mSetMode.dwAcqMode = PAS2000_ACQ_SINGLE                 ' ANCWV[h
    ' gKݒ
    mSetMode.dwTrigMode = PAS2000_TMODE_AUTO                ' gK[h
    mSetMode.dwTrigSource = PAS2000_TSRC_CH1                ' gK\[X
    mSetMode.dwTrigCoupling = PAS2000_TCUP_DC               ' gK͌
    mSetMode.dwTrigSlope = PAS2000_TSLP_POS                 ' gKX[v
    mSetMode.dwTrigLevel = 250                              ' gKx
    mSetMode.dwTrigPos = 5000                               ' gK|WV
    mSetMode.dwTrigDelay = 0                                ' gKfBC
    mSetMode.dwTrigPulse = PAS2000_PULSE_NONE               ' pXgK(pX)
    mSetMode.dwTrigPulseWidth = 0                           ' pXgK(pX)
    If Pas2000wSetMode(mwDeviceNo, mSetMode) = False Then
        ErrorMessage (mwDeviceNo)
    End If
    szbuf = "TvO샂[hݒ" + Chr(10) + _
            " yݒz" + Chr(10) + _
            "   CH1 XP[ : " + Format(mSetMode.dwVoltDiv(PAS2000_CH1)) + Chr(10) + _
            "   CH2 XP[ : " + Format(mSetMode.dwVoltDiv(PAS2000_CH2)) + Chr(10) + _
            "   CH1 |WV : " + Format(mSetMode.dwVoltPos(PAS2000_CH1)) + Chr(10) + _
            "   CH2 |WV : " + Format(mSetMode.dwVoltPos(PAS2000_CH2)) + Chr(10) + _
            "   CH1 ͌ : " + Format(mSetMode.dwVertCoupling(PAS2000_CH1)) + Chr(10) + _
            "   CH2 ͌ : " + Format(mSetMode.dwVertCoupling(PAS2000_CH2)) + Chr(10) + _
            " yݒz" + Chr(10) + _
            "   TCY : " + Format(mSetMode.dwMemSize) + Chr(10) + _
            "   TvO^C : " + Format(mSetMode.dwSamplingTime) + Chr(10) + _
            "   CH1 gш : " + Format(mSetMode.dwBandWidth(PAS2000_CH1)) + Chr(10) + _
            "   CH2 gш : " + Format(mSetMode.dwBandWidth(PAS2000_CH2)) + Chr(10) + _
            "   TvO[h : " + Format(mSetMode.dwSamplingMode) + Chr(10) + _
            "   ANCWV[h : " + Format(mSetMode.dwAcqMode) + Chr(10) + _
            " ygKݒz" + Chr(10) + _
            "   [h : " + Format(mSetMode.dwTrigMode) + Chr(10) + _
            "   \[X : " + Format(mSetMode.dwTrigSource) + Chr(10) + _
            "   ͌ : " + Format(mSetMode.dwTrigCoupling) + Chr(10) + _
            "   X[v : " + Format(mSetMode.dwTrigSlope) + Chr(10) + _
            "   x : " + Format(mSetMode.dwTrigLevel) + Chr(10) + _
            "   |WV : " + Format(mSetMode.dwTrigPos) + Chr(10) + _
            "   fBC : " + Format(mSetMode.dwTrigDelay) + Chr(10) + _
            "   pX : " + Format(mSetMode.dwTrigPulse) + Chr(10) + _
            "   pX : " + Format(mSetMode.dwTrigPulseWidth)
    ResultMessage (szbuf)
    '-----------------------------------------------------------
    ' TvOJn
    '-----------------------------------------------------------
    ResultMessage ("TvOJn܂B")
    If Pas2000wStartSampling(mwDeviceNo, 0) = False Then
        ErrorMessage (mwDeviceNo)
    End If
End Sub
'--------------------------------------------------------------------
' I
'--------------------------------------------------------------------
Public Sub OnUnLoad()
    '-----------------------------------------------------------
    ' foCX̎gpJ
    '-----------------------------------------------------------
    If Pas2000wClose(mwDeviceNo) = False Then
        ErrorMessage (mwDeviceNo)
    End If
    ResultMessage ("foCXJ܂B")
    '-----------------------------------------------------------
    ' DLL̎gpJ
    '-----------------------------------------------------------
    If Pas2000wDllClose() = False Then
        MsgBox "pas2000.dll ̃A[hɎs܂B", vbOKOnly + vbInformation, szTitle
    End If
End Sub
'--------------------------------------------------------------------
' EBhEbZ[W
'--------------------------------------------------------------------
Public Function WindowProc(ByVal hWnd As Long, ByVal uMsg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
    If uMsg = WM_PAS2000_DATA_READY Then
        Call DataReady(CInt(wParam), CLng(lParam))
        Exit Function
    End If

    If uMsg = WM_PAS2000_ERROR Then
        Call DataThreadError(CInt(wParam), CLng(lParam))
        Exit Function
    End If

    WindowProc = CallWindowProc(lpPrevWndProc, hWnd, uMsg, wParam, lParam)
End Function
'--------------------------------------------------------------------
' TvOf[^
'--------------------------------------------------------------------
Private Sub DataReady(ByVal wParam As Integer, ByVal lParam As Long)

    Dim szbuf As String
    Dim dwStatus As Long
    Dim dwNumData As Long
    Dim dwInitArg As Long
    Dim dwData As Long
    Dim i As Integer

    If lParam <> PAS2000_DEVICE_ID Then
        Exit Sub
    End If
    '-----------------------------------------------------------
    ' TvO~
    '-----------------------------------------------------------
    If Pas2000wStopSampling(wParam) = False Then
        ErrorMessage (wParam)
    End If
    ResultMessage ("TvO~܂B")
    '-----------------------------------------------------------
    ' TvOXe[^X擾
    '-----------------------------------------------------------
    If Pas2000wGetStatus(wParam, dwStatus, dwNumData, dwInitArg) = False Then
        ErrorMessage (wParam)
    End If
    szbuf = "TvOXe[^X擾" + Chr(10) + _
            "   TvOXe[^X : &H" + Hex(dwStatus) + Chr(10) + _
            "   ǃTvOf[^ : " + Format(dwNumData)
    ResultMessage (szbuf)
    '-----------------------------------------------------------
    ' TvOf[^擾
    '-----------------------------------------------------------
    If dwNumData > 0 Then
        ReDim mpdwADData(1 To dwNumData)
        
        If Pas2000wGetData(wParam, dwNumData, mpdwADData) = False Then
            ErrorMessage (wParam)
        End If
        szbuf = "TvOf[^ " + Format(dwNumData) + " 擾܂B" + Chr(10) + Chr(10) + _
                "CH1 擾f[^" + Chr(10)
        For i = 4990 To 5010    ' 擾f[^\
            dwData = mpdwADData(i) And ADDATA_MASK_BIT                  ' CH1
            'dwData = (mpdwADData(i) \ CLng(2 ^ 16)) And ADDATA_MASK_BIT ' CH2
            szbuf = szbuf + "   " + Format(i) + " : " + Format(dwData) + _
                    " ( " + FormatNumber(VoltValue(dwData), 2, vbTrue, vbUseDefault, vbFalse) + " )" + Chr(10)
        Next i
        szbuf = szbuf + Chr(10) + _
                " gKʒu : " + Format(mSetMode.dwTrigPos) + " ̑O10\" + Chr(10) + _
                "@@JbR͓dl(PmV)"
        ResultMessage (szbuf)
    End If
    '-----------------------------------------------------------
    ' I
    '-----------------------------------------------------------
    Call SendMessage(ghWnd, WM_CLOSE, 0, 0)
End Sub
'--------------------------------------------------------------------
' dlZ
'--------------------------------------------------------------------
Private Function VoltValue(ByVal addata As Long) As Double
    Dim voltdiv As Long
    Dim vfull As Double

    ' Volt/div
    Select Case mSetMode.dwVoltDiv(PAS2000_CH1)
        Case PAS2000_VOLTDIV_0
            voltdiv = 10
        Case PAS2000_VOLTDIV_1
            voltdiv = 20
        Case PAS2000_VOLTDIV_2
            voltdiv = 50
        Case PAS2000_VOLTDIV_3
            voltdiv = 100
        Case PAS2000_VOLTDIV_4
            voltdiv = 200
        Case PAS2000_VOLTDIV_5
            voltdiv = 500
        Case PAS2000_VOLTDIV_6
            voltdiv = 1000
        Case PAS2000_VOLTDIV_7
            voltdiv = 2000
        Case Else
            voltdiv = 0
    End Select
    ' tXP[d(v[u10:1)
    vfull = voltdiv * PAS2000_PROBE_X10 * 10
    ' dlɊZ
    VoltValue = (vfull * addata / PAS2000_RES_VERT) _
              - (vfull * mSetMode.dwVoltPos(PAS2000_CH1) / PAS2000_RES_VOLTPOS)
End Function
'--------------------------------------------------------------------
' TvOf[^擾pXbhG[
'--------------------------------------------------------------------
Private Sub DataThreadError(ByVal wParam As Integer, ByVal lParam As Long)
    If lParam = PAS2000_DEVICE_ID Then
        ErrorMessage (wParam)
    End If
End Sub
'--------------------------------------------------------------------
' TuNXs
'--------------------------------------------------------------------
Public Sub Hook()
    lpPrevWndProc = SetWindowLong(ghWnd, GWL_WNDPROC, AddressOf WindowProc)
End Sub
'--------------------------------------------------------------------
' TuNX
'--------------------------------------------------------------------
Public Sub Unhook()
    Dim temp As Long
    temp = SetWindowLong(ghWnd, GWL_WNDPROC, lpPrevWndProc)
End Sub
'--------------------------------------------------------------------
' ʂ\
'--------------------------------------------------------------------
Private Sub ResultMessage(lpszbuf As String)
    MsgBox lpszbuf, vbOKOnly + vbInformation, szTitle
End Sub
'--------------------------------------------------------------------
' G[bZ[W\
'--------------------------------------------------------------------
Private Sub ErrorMessage(ByVal devno As Integer)
    Dim dwRes As Long
    Dim szbuf As String

    dwRes = Pas2000wGetLastError(devno)
    If PAS2000_ERR_WRAPDLL = dwRes Then
        szbuf = "DLL Load error"
    Else
        szbuf = "PA-S2000 error" + Chr(10) + Chr(10) + _
                "Error code : &H" + Hex(dwRes)
    End If
    
    MsgBox szbuf, vbOKOnly + vbCritical, szTitle
    End
End Sub
