//===================================================================
// pas2000w.pas
//-------------------------------------------------------------------
//
// PA-S2000 Wrapper
//
//===================================================================
unit pas2000w;

interface

uses
  Windows;

const
	//-----------------------------------------------------------------
  // foCXANZXɊւ`
  //-----------------------------------------------------------------
  PAS2000_MAX_DEVICE					 = 16;						// őfoCX
  PAS2000_DEVICE_AUTO					 = Word(not 0);		// foCXw
  //-----------------------------------------------------------------
  // `lɊւ`
  //-----------------------------------------------------------------
  PAS2000_NUM_CH							 = 2;							// Ή`l
  PAS2000_CH1									 = 0;							// CH1
  PAS2000_CH2									 = 1;							// CH2
  //-----------------------------------------------------------------
  // foCXɊւ`
  //-----------------------------------------------------------------
  PAS2000_VID_LENGTH					 = 8;							// x_ʕ
  PAS2000_PID_LENGTH					 = 16;						// v_Ngʕ
  //-----------------------------------------------------------------
  // TvOXe[^X̒`
  //-----------------------------------------------------------------
  PAS2000_STS_STOP						 = $0;						// CxgȂ(~)
  PAS2000_STS_PRE_TRIG				 = $1;						// gK҂ɂȂȌ
  PAS2000_STS_WAIT_FOR_TRIG		 = $3;						// gK҂̏
  PAS2000_STS_TRIG_DETECT			 = $7;						// gK|
  PAS2000_STS_AUTO_RUN				 = $B;						// ^CAEgt[ōăX^[g
  //-----------------------------------------------------------------
  // G[R[h̒`
  //-----------------------------------------------------------------
  PAS2000_SUCCESS							 = 0;							// ُȂ
  PAS2000_ERR_SYSTEM					 = 1;							// VXeG[
  PAS2000_ERR_NO_DEVICE				 = 2;							// gp\ȃfoCX܂
  PAS2000_ERR_IN_USE					 = 3;							// w̃foCX͎gpł
  PAS2000_ERR_INVALID_DEVICENO = 4;							// sȃfoCXʔԍł
  PAS2000_ERR_INVALID_ARGUMENT = 5;							// sȈw肳܂
  PAS2000_ERR_INTERNAL				 = 6;							// G[ł
  PAS2000_ERR_TRANSFER_TIMEOUT = 7;							// f[^]^CAEgɂȂ܂
  PAS2000_ERR_TRANSFER_CANCEL	 = 8;							// f[^]LZ܂
  PAS2000_ERR_TRANSFER_FAIL		 = 9;							// f[^]s܂
  PAS2000_ERR_BUFF_OVERFLOW		 = 10;						// obt@I[o[t[܂
  PAS2000_ERR_MEMSIZE					 = 11;						// 擾TCYُł
  PAS2000_ERR_DEVICE					 = 12;						// foCXG[ł
  PAS2000_ERR_WRAPDLL					 = DWord(-1);			// bp[֐G[
  //-----------------------------------------------------------------
  // bZ[W̒`
  //-----------------------------------------------------------------
  WM_DATA_READY								 = 1;							// TvOf[^
  WM_DATA_THREAD_ERROR				 = 2;							// f[^擾pXbhG[
  //-----------------------------------------------------------------
  // ̑̒`
  //-----------------------------------------------------------------
  PAS2000_DEVICE_ID						 = $5320;					// foCXID
  PAS2000_DLL_NAME						 = 'pas2000.dll';	// DLLt@C
  PAS2000_RES_VERT						 = 1024;					// \(1024|Cg)
  PAS2000_RES_VOLTPOS					 = 500;						// d|WV\
  ADBUFF_MAX_SIZE							 = 1000000;				// ݍőf[^
  ADDATA_MASK_BIT							 = $000003FF;			// rbg}XN
  //-----------------------------------------------------------------
  // eݒl̒`
  //-----------------------------------------------------------------
  // (d)XP[
  PAS2000_VOLTDIV_0						 = 0;							// 10mV  or 100mV
  PAS2000_VOLTDIV_1						 = 1;							// 20mV  or 200mV
  PAS2000_VOLTDIV_2						 = 2;							// 50mV  or 500mV
  PAS2000_VOLTDIV_3						 = 3;							// 100mV or 1V
  PAS2000_VOLTDIV_4						 = 4;							// 200mV or 2V
  PAS2000_VOLTDIV_5						 = 5;							// 500mV or 5V
  PAS2000_VOLTDIV_6						 = 6;							// 1V    or 10V
  PAS2000_VOLTDIV_7						 = 7;							// 2V    or 20V
  // v[u
  PAS2000_PROBE_X1						 = 1;							// 1:1
  PAS2000_PROBE_X10						 = 10;						// 10:1
  PAS2000_PROBE_X100					 = 100;						// 100:1
  // ͌
  PAS2000_CUP_DC							 = 0;							// DC
  PAS2000_CUP_AC							 = 1;							// AC
  // TCY
  PAS2000_MEMSIZE_10K					 = 0;							// 10kPoint
  PAS2000_MEMSIZE_100K				 = 1;							// 100kPoint
  PAS2000_MEMSIZE_1M					 = 2;							// 1MPoint
  // ()XP[
  PAS2000_TIMEDIV_10NS				 = 10;						// 10ns
  PAS2000_TIMEDIV_20NS				 = 20;						// 20ns
  PAS2000_TIMEDIV_50NS				 = 50;						// 50ns
  PAS2000_TIMEDIV_100NS				 = 100;						// 100ns
  PAS2000_TIMEDIV_200NS				 = 200;						// 200ns
  PAS2000_TIMEDIV_500NS				 = 500;						// 500ns
  PAS2000_TIMEDIV_1US					 = 1000;					// 1us
  PAS2000_TIMEDIV_2US					 = 2000;					// 2us
  PAS2000_TIMEDIV_5US					 = 5000;					// 5us
  PAS2000_TIMEDIV_10US				 = 10000;					// 10us
  PAS2000_TIMEDIV_20US				 = 20000;					// 20us
  PAS2000_TIMEDIV_50US				 = 50000;					// 50us
  PAS2000_TIMEDIV_100US				 = 100000;				// 100us
  PAS2000_TIMEDIV_200US				 = 200000;				// 200us
  PAS2000_TIMEDIV_500US				 = 500000;				// 500us
  PAS2000_TIMEDIV_1MS					 = 1000000;				// 1ms
  PAS2000_TIMEDIV_2MS					 = 2000000;				// 2ms
  PAS2000_TIMEDIV_5MS					 = 5000000;				// 5ms
  PAS2000_TIMEDIV_10M					 = 10000000;			// 10ms
  // gш
  PAS2000_BW_FULL							 = 0;							// FULL
  PAS2000_BW_20MHZ						 = 1;							// 20MHz
  // TvO[h
  PAS2000_SMP_REAL						 = 0;							// ATvO
  // ANCWV[h
  PAS2000_ACQ_SINGLE					 = 0;							// VOVbg
  PAS2000_ACQ_ROLL						 = 1;							// [
  // gK[h
  PAS2000_TMODE_AUTO					 = 0;							// I[g
  PAS2000_TMODE_NORMAL				 = 1;							// m[}
  PAS2000_TMODE_FREERUN				 = 2;							// t[
  // gK\[X
  PAS2000_TSRC_CH1						 = 0;							// CH1
  PAS2000_TSRC_CH2						 = 1;							// CH2
  PAS2000_TSRC_EXT						 = 2;							// O
  // gK͌
  PAS2000_TCUP_DC							 = 0;							// DC
  PAS2000_TCUP_LF							 = 1;							// LFrej
  PAS2000_TCUP_HF							 = 2;							// HFrej
  // gKX[v
  PAS2000_TSLP_POS						 = 0;							// (オ)
  PAS2000_TSLP_NEG						 = 1;							// ()
  // pXgK(pX)
  PAS2000_PULSE_NONE					 = 0;							// gp
  PAS2000_PULSE_UNDER					 = 1;							// pX
  PAS2000_PULSE_ABOVE					 = 2;							// pXȏ

type
	//-----------------------------------------------------------------
  // foCX\
  //-----------------------------------------------------------------
  TDEVINFO = record
  	VendorID:  array [0..PAS2000_VID_LENGTH - 1] of Byte;	// x_ʕ
    ProductID: array [0..PAS2000_PID_LENGTH - 1] of Byte;	// v_Ngʕ
    FirmVer:   Byte;																			// t@[EFÃo[W
    FpgaVer:   Byte;																			// FPGÃo[W
  end;
  //-----------------------------------------------------------------
  // TvOp[^\
  //-----------------------------------------------------------------
  TSETMODE = record
  	// ݒ
    dwVoltDiv:        array [0..PAS2000_NUM_CH - 1] of DWord;	// (d)XP[
    dwVoltPos:        array [0..PAS2000_NUM_CH - 1] of DWord;	// (d)|WV
    dwVertCoupling:   array [0..PAS2000_NUM_CH - 1] of DWord;	// ͌
    // ݒ
    dwMemSize:        DWord;																	// TCY
    dwSamplingTime:   DWord;																	// ()XP[
    dwBandWidth:      array [0..PAS2000_NUM_CH - 1] of DWord;	// gш
    dwSamplingMode:   DWord;																	// TvO[h
    dwAcqMode:        DWord;																	// ANCWV[h
    // gKݒ
    dwTrigMode:       DWord;																	// gK[h
    dwTrigSource:     DWord;																	// gK\[X
    dwTrigCoupling:   DWord;																	// gK͌
    dwTrigSlope:      DWord;																	// gKX[v
    dwTrigLevel:      DWord;																	// gKx
    dwTrigPos:        DWord;																	// gK|WV
    dwTrigDelay:      DWord;																	// gKfBC
    dwTrigPulse:      DWord;																	// pXgK(pX)
    dwTrigPulseWidth: DWord;																	// pXgK(pX)
  end;

//-------------------------------------------------------------------
// ֐̎gp錾
//-------------------------------------------------------------------
// DLL[h
function Pas2000wDllOpen: Boolean;
// DLLN[Y
function Pas2000wDllClose: Boolean;
// o[W擾
function Pas2000wGetVersion(var pdwDrvVer: DWord;
														var pdwDllVer: DWord): Boolean;
// foCX̌
function Pas2000wCreate(var pwDeviceNo: Word;
												hWnd: THandle;
                        uWMBase: Integer): Boolean;
// foCX̊J
function Pas2000wClose(wDeviceNo: Word): Boolean;
// foCX擾
function Pas2000wGetDevInfo(wDeviceNo: Word; var pDevInfo: TDEVINFO): Boolean;
// TCY擾
function Pas2000wGetMemSize(wDeviceNo: Word; var pdwMemSize: DWord): Boolean;
// TvO샂[h̐ݒ
function Pas2000wSetMode(wDeviceNo: Word; var pSetMode: TSETMODE): Boolean;
// TvOJn
function Pas2000wStartSampling(wDeviceNo: Word; dwInitArg: DWord): Boolean;
// TvO~
function Pas2000wStopSampling(wDeviceNo: Word): Boolean;
// TvOXe[^X擾
function Pas2000wGetStatus(wDeviceNo: Word;
													 var pdwStatus: DWord;
                           var pdwNumData: DWord;
                           var pvInitArg): Boolean;
// TvOf[^擾
function Pas2000wGetData(wDeviceNo: Word;
												 dwNumData: DWord;
                         var pdwData): Boolean;
// G[R[h
function Pas2000wGetLastError(wDeviceNo: Word): DWord;


implementation

{$J+}	// ^t萔̕ύX\RpCw

const
	hDLL: THandle = 0;	// DLLnh

type
	TPas2000GetVersion = function(var pdwDrvVer: DWord;
  															var pdwDllVer: DWord): Boolean; stdcall;
  TPas2000Create = function(var pwDeviceNo: Word;
  													hWnd: THandle;
                            uWMBase: Integer): Boolean; stdcall;
  TPas2000Close = function(wDeviceNo: Word): Boolean; stdcall;
  TPas2000GetDevInfo = function(wDeviceNo: Word; var pDevInfo: TDEVINFO): Boolean; stdcall;
  TPas2000GetMemSize = function(wDeviceNo: Word; var pdwMemSize: DWord): Boolean; stdcall;
  TPas2000SetMode = function(wDeviceNo: Word; var pSetMode: TSETMODE): Boolean; stdcall;
  TPas2000StartSampling = function(wDeviceNo: Word; dwInitArg: DWord): Boolean; stdcall;
  TPas2000StopSampling = function(wDeviceNo: Word): Boolean; stdcall;
  TPas2000GetStatus = function(wDeviceNo: Word;
  														 var pdwStatus: DWord;
                               var pdwNumData: DWord;
                               var pvInitArg): Boolean; stdcall;
  TPas2000GetData = function(wDeviceNo: Word;
  													 dwNumData: DWord;
                             var pdwData): Boolean; stdcall;
  TPas2000GetLastError = function(wDeviceNo: Word): DWord; stdcall;

// DLLGNX|[g֐AhX̊i[ϐ
var
	pPas2000GetVersion: TPas2000GetVersion;
  pPas2000Create: TPas2000Create;
  pPas2000Close: TPas2000Close;
  pPas2000GetDevInfo: TPas2000GetDevInfo;
  pPas2000GetMemSize: TPas2000GetMemSize;
  pPas2000SetMode: TPas2000SetMode;
  pPas2000StartSampling: TPas2000StartSampling;
  pPas2000StopSampling: TPas2000StopSampling;
  pPas2000GetStatus: TPas2000GetStatus;
  pPas2000GetData: TPas2000GetData;
  pPas2000GetLastError: TPas2000GetLastError;

function _GetDllExportFunc: Boolean; forward;

{$J-}

//-------------------------------------------------------------------
// 		DLL[h(񃍁[h̓G[Ƃ)
// 		
// ߂l  True
//				s False
//-------------------------------------------------------------------
function Pas2000wDllOpen: Boolean;
begin
	Result := False;
  if hDLL <> 0 then Exit;
  hDLL := LoadLibrary(PAS2000_DLL_NAME);
  if hDLL = 0 then Exit;
  if _GetDllExportFunc = False then begin
  	Pas2000wDllClose;	// DLL֐擾ɎŝDLLN[Y
    Exit;
  end;
  Result := True
end;
//-------------------------------------------------------------------
// 		DLLA[h(A[h̓G[Ƃ)
// 		
// ߂l  True
//				s False
//-------------------------------------------------------------------
function Pas2000wDllClose: Boolean;
begin
	Result := True;
  if hDLL = 0 then Exit;
  if True = FreeLibrary(hDLL) then hDLL := 0
  else Result := False;
end;
//-------------------------------------------------------------------
// 		o[W擾
// 		pdwDrvVer		hCõo[Wi[̈ւ̃|C^
//				pdwDllVer		DLL̃o[Wi[̈ւ̃|C^
// ߂l  True
//				s False
//-------------------------------------------------------------------
function Pas2000wGetVersion(var pdwDrvVer: DWord;
														var pdwDllVer: DWord): Boolean;
begin
	Result := False;
  if hDLL = 0 then Exit;
  Result := pPas2000GetVersion(pdwDrvVer, pdwDllVer);
end;
//-------------------------------------------------------------------
// 		foCX̌
// 		pwDeviceNo  gpfoCX̃foCXʔԍi[̈ւ
//										|C^
//				hWnd				DLLo郁bZ[W󂯎EBhẼnh
//				uWMBase			o郁bZ[WID̃x[Xl
// ߂l  True
//				s False
//-------------------------------------------------------------------
function Pas2000wCreate(var pwDeviceNo: Word;
												hWnd: THandle;
                        uWMBase: Integer): Boolean;
begin
	Result := False;
  if hDLL = 0 then Exit;
  Result := pPas2000Create(pwDeviceNo, hWnd, uWMBase);
end;
//-------------------------------------------------------------------
// 		foCX̊J
// 		wDeviceNo		ΏۃfoCX̃foCXʔԍ
// ߂l  True
//				s False
//-------------------------------------------------------------------
function Pas2000wClose(wDeviceNo: Word): Boolean;
begin
	Result := False;
  if hDLL = 0 then Exit;
  Result := pPas2000Close(wDeviceNo);
end;
//-------------------------------------------------------------------
// 		foCX̎擾
// 		wDeviceNo		ΏۃfoCX̃foCXʔԍ
//				pDevInfo		foCXi[\̂ւ̃|C^
// ߂l  True
//				s False
//-------------------------------------------------------------------
function Pas2000wGetDevInfo(wDeviceNo: Word; var pDevInfo: TDEVINFO): Boolean;
begin
	Result := False;
  if hDLL = 0 then Exit;
  Result := pPas2000GetDevInfo(wDeviceNo, pDevInfo);
end;
//-------------------------------------------------------------------
// 		TCY̎擾
// 		wDeviceNo		ΏۃfoCX̃foCXʔԍ
//				pdwMemSize	Ă郁TCYi[̈ւ̃|C^
// ߂l  True
//				s False
//-------------------------------------------------------------------
function Pas2000wGetMemSize(wDeviceNo: Word; var pdwMemSize: DWord): Boolean;
begin
	Result := False;
  if hDLL = 0 then Exit;
  Result := pPas2000GetMemSize(wDeviceNo, pdwMemSize);
end;
//-------------------------------------------------------------------
// 		TvO샂[h̐ݒ
// 		wDeviceNo		ΏۃfoCX̃foCXʔԍ
//				pSetMode		ݒi[Ă\̂̃|C^
// ߂l  True
//				s False
//-------------------------------------------------------------------
function Pas2000wSetMode(wDeviceNo: Word; var pSetMode: TSETMODE): Boolean;
begin
	Result := False;
  if hDLL = 0 then Exit;
  Result := pPas2000SetMode(wDeviceNo, pSetMode);
end;
//-------------------------------------------------------------------
// 		TvO̊Jn
// 		wDeviceNo		ΏۃfoCX̃foCXʔԍ
//				dwInitArg		\(0w)
// ߂l  True
//				s False
//-------------------------------------------------------------------
function Pas2000wStartSampling(wDeviceNo: Word; dwInitArg: DWord): Boolean;
begin
	Result := False;
  if hDLL = 0 then Exit;
  Result := pPas2000StartSampling(wDeviceNo, dwInitArg);
end;
//-------------------------------------------------------------------
// 		TvO̒~
// 		wDeviceNo		ΏۃfoCX̃foCXʔԍ
// ߂l  True
//				s False
//-------------------------------------------------------------------
function Pas2000wStopSampling(wDeviceNo: Word): Boolean;
begin
	Result := False;
  if hDLL = 0 then Exit;
  Result := pPas2000StopSampling(wDeviceNo);
end;
//-------------------------------------------------------------------
// 		TvOXe[^X擾
// 		wDeviceNo		ΏۃfoCX̃foCXʔԍ
//				pdwStatus		TvOXe[^X
//				pdwNumData	ǃTvOf[^
//				pvInitArg		\
// ߂l  True
//				s False
//-------------------------------------------------------------------
function Pas2000wGetStatus(wDeviceNo: Word;
													 var pdwStatus: DWord;
                           var pdwNumData: DWord;
                           var pvInitArg): Boolean;
begin
	Result := False;
  if hDLL = 0 then Exit;
  Result := pPas2000GetStatus(wDeviceNo, pdwStatus, pdwNumData, pvInitArg);
end;
//-------------------------------------------------------------------
// 		TvOf[^擾
// 		wDeviceNo		ΏۃfoCX̃foCXʔԍ
//				dwNumData		擾f[^
//				pdwData			擾f[^i[̈ւ̃|C^
// ߂l  True
//				s False
//-------------------------------------------------------------------
function Pas2000wGetData(wDeviceNo: Word;
												 dwNumData: DWord;
                         var pdwData): Boolean;
begin
	Result := False;
  if hDLL = 0 then Exit;
  Result := pPas2000GetData(wDeviceNo, dwNumData, pdwData);
end;
//-------------------------------------------------------------------
// 		G[R[h̎擾
// 		wDeviceNo		ΏۃfoCX̃foCXʔԍ
// ߂l G[R[h
//-------------------------------------------------------------------
function Pas2000wGetLastError(wDeviceNo: Word): DWord;
begin
	Result := PAS2000_ERR_WRAPDLL;
  if hDLL = 0 then Exit;
  Result := pPas2000GetLastError(wDeviceNo);
end;
//-------------------------------------------------------------------
// 		DLLGNX|[g֐AhX̎擾
// 		
// ߂l  True
//				s False
//-------------------------------------------------------------------
function _GetDllExportFunc: Boolean;
begin
	Result := False;

  // Pas2000GetVersioñAhX擾
  pPas2000GetVersion := GetProcAddress(hDLL, 'Pas2000GetVersion');
  if @pPas2000GetVersion = nil then Exit;
  // Pas2000CreatẽAhX擾
  pPas2000Create := GetProcAddress(hDLL, 'Pas2000Create');
  if @pPas2000Create = nil then Exit;
  // Pas2000ClosẽAhX擾
  pPas2000Close := GetProcAddress(hDLL, 'Pas2000Close');
  if @pPas2000Close = nil then Exit;
  // Pas2000GetDevInfõAhX擾
  pPas2000GetDevInfo := GetProcAddress(hDLL, 'Pas2000GetDevInfo');
  if @pPas2000GetDevInfo = nil then Exit;
  // Pas2000GetMemSizẽAhX擾
  pPas2000GetMemSize := GetProcAddress(hDLL, 'Pas2000GetMemSize');
  if @pPas2000GetMemSize = nil then Exit;
  // Pas2000SetModẽAhX擾
  pPas2000SetMode := GetProcAddress(hDLL, 'Pas2000SetMode');
  if @pPas2000SetMode = nil then Exit;
  // Pas2000StartSampling̃AhX擾
  pPas2000StartSampling := GetProcAddress(hDLL, 'Pas2000StartSampling');
  if @pPas2000StartSampling = nil then Exit;
  // Pas2000StopSampling̃AhX擾
  pPas2000StopSampling := GetProcAddress(hDLL, 'Pas2000StopSampling');
  if @pPas2000StopSampling = nil then Exit;
  // Pas2000GetStatus̃AhX擾
  pPas2000GetStatus := GetProcAddress(hDLL, 'Pas2000GetStatus');
  if @pPas2000GetStatus = nil then Exit;
  // Pas2000GetDatãAhX擾
  pPas2000GetData := GetProcAddress(hDLL, 'Pas2000GetData');
  if @pPas2000GetData = nil then Exit;
  // Pas2000GetLastError̃AhX擾
  pPas2000GetLastError := GetProcAddress(hDLL, 'Pas2000GetLastError');
  if @pPas2000GetLastError = nil then Exit;

  // SĂDLLGNX|[g֐AhX擾OK
  Result := True;
end;

end.
