//===================================================================
// pas2000w.h
//-------------------------------------------------------------------
//
// PA-S2000 Wrapper Header
//
//===================================================================
#ifndef __INC_PAS2000W_H__
#define __INC_PAS2000W_H__

#include "pas2000.h"

#ifdef __cplusplus
extern "C"{
#endif


#define PAS2000_DLL_NAME		_T( "pas2000.dll" )		// DLLt@C
#define PAS2000_ERR_WRAPDLL		( (DWORD)-1 )			// bp[֐G[


// DLL[h
BOOL	Pas2000wDllOpen( void );
// DLLN[Y
BOOL	Pas2000wDllClose( void );
// o[W擾
BOOL	Pas2000wGetVersion( PDWORD pdwDrvVer, PDWORD pdwDllVer );
// foCX̌
BOOL	Pas2000wCreate( PWORD pwDeviceNo, HWND hWnd, UINT uWMBase );
// foCX̊J
BOOL	Pas2000wClose( WORD wDeviceNo );
// foCX擾
BOOL	Pas2000wGetDevInfo( WORD wDeviceNo, TDEVINFO *pDevInfo );
// TCY擾
BOOL	Pas2000wGetMemSize( WORD wDeviceNo, PDWORD pdwMemSize );
// TvO샂[h̐ݒ
BOOL	Pas2000wSetMode( WORD wDeviceNo, TSETMODE *pSetMode );
// TvOJn
BOOL	Pas2000wStartSampling( WORD wDeviceNo, DWORD dwInitArg );
// TvO~
BOOL	Pas2000wStopSampling( WORD wDeviceNo );
// TvOXe[^X擾
BOOL	Pas2000wGetStatus( WORD wDeviceNo, PDWORD pdwStatus, PDWORD pdwNumData, PVOID pvInitArg );
// TvOf[^擾
BOOL	Pas2000wGetData( WORD wDeviceNo, DWORD dwNumData, PDWORD pdwData );
// G[R[h
DWORD	Pas2000wGetLastError( WORD wDeviceNo );

#ifdef __cplusplus
}
#endif

#endif // __INC_PAS2000W_H__
